# FD2LyX.py  Copyright Richard Harris 2001
#
# author: Richard Harris (paladin@i1.net)
# The author releases this file under the GPL
# license. See COPYING for specifics.
# (COPYING is included in the LyX distribution.)
#
# created: 09oct01
# change log:
# (1) 12oct01  refined handling of SUPER:
import string, sys


class FD2LyX:

	def __init__(self):
		self.wasSpeaker = 0
		self.wasParen = 0
		self.wasScene = 0
		return

	def header_plate(self, outfile):
		outfile.write("""#LyX 1.1 created this file. For more info see http://www.lyx.org/
\\lyxformat 218
\\textclass hollywood
\\language english
\\inputencoding default
\\fontscheme default
\\graphics default
\\paperfontsize 12
\\spacing single
\\papersize letterpaper
\\paperpackage a4
\\use_geometry 1
\\use_amsmath 0
\\paperorientation portrait
\\leftmargin 1.6in
\\topmargin 0.5in
\\rightmargin 0.75in
\\bottommargin 0.75in
\\headheight 0.5in
\\headsep 12bp
\\footskip 0.5in
\\secnumdepth 2
\\tocdepth 2
\\paragraph_separation indent
\\defskip medskip
\\quotes_language english
\\quotes_times 2
\\papercolumns 1
\\papersides 1
\\paperpagestyle default

\\layout Title

<your title>
\\layout Author
\\added_space_bottom vfill 
<your name>
\\layout Right Address

<your address>
\\newline 
<continued>
\\layout General


\\latex latex 

\\backslash 
setlength{
\\backslash 
dialogindent}{1in}
\\layout General


\\latex latex 

\\backslash 
setlength{
\\backslash 
parenoffset}{.5in}
\\layout General


\\latex latex 

\\backslash 
setlength{
\\backslash 
dialogLength}{4in}
\\layout General


\\latex latex 

\\backslash 
setlength{
\\backslash 
parenLength}{3in}
\\layout General


\\latex latex 

\\backslash 
setlength{
\\backslash 
speakeroffset}{1.2in}
\\layout FADE IN:
\\pagebreak_top
\\layout General


\\latex latex 

\\backslash 
pagenumbering{arabic}
""")
		return

	def element(self, line, outfile):
		if  string.find(line, "FADE IN") == 0:
			return
		outfile.write("\\layout ")
		if string.find(line, "INT.") == 0:
			outfile.write("INT.")
			self.wasScene = 1
		elif string.find(line, "EXT.") == 0:
			outfile.write("EXT.")
			self.wasScene = 1
		elif  string.find(line, "FADE OUT") == 0:
			outfile.write("FADE OUT")
		elif  (string.find(line, "TITLE OVER") == 0) or (string.find(line, "SUPER:") == 0):	# (1)
			outfile.write("TITLE OVER:")
		elif line == string.upper(line):
			outfile.write("Speaker")
			self.wasSpeaker = 1
			self.wasScene = 0
		elif string.find(line, "(") == 0:
			outfile.write("Parenthetical")
			self.wasParen = 1
		elif self.wasSpeaker or self.wasParen:
			outfile.write("Dialogue")
			self.wasSpeaker = 0
			self.wasParen = 0
		elif self.wasScene:
			outfile.write("Description")
		else:
			outfile.write("Narrative")
		outfile.write("\n\n")
		return

	def parse(self, line, outfile):
		if  string.find(line, "FADE") == 0:
			return
		line = string.replace(line, "  ", " ")
		line = string.replace(line, "", "'") # replace high-bit with low-bit
		line = string.replace(line, "", "'")
		line = string.replace(line, "", "\"")
		line = string.replace(line, "", "\"")
		if string.find(line, "INT.") == 0:
			line = string.replace(line, "INT.", "", 1)
		elif string.find(line, "EXT.") == 0:
			line = string.replace(line, "EXT.", "", 1)
		elif string.find(line, "TITLE OVER") == 0:
			line = string.replace(line, "TITLE OVER:", "", 1)
		elif string.find(line, "SUPER:") == 0:
			line = string.replace(line, "SUPER:", "", 1)
		elif self.wasParen:
			line = string.replace(line, "(", "")
			line = string.replace(line, ")", "")
		self.writeElement(line, outfile)
		return

	def writeElement(self, line, outfile):
		count = 0
		end = 79
		space = string.rfind(line, " ", end)
		for character in line:
			outfile.write(character)
			count = count + 1
			if (character == ".") or (count == space):
				outfile.write("\n")
				end = end + 80
				space = string.rfind(line, " ", end)
		return

	def convert(self, file):
		# read up input file
		f = open(file, 'r')
		infile = f.readlines()
		f.close()
		# get name
		file = string.split(file, ".")
		name = file[0]
		# create output file
		outfile = open( name + ".lyx", 'w')
		# write header to FADE IN:
		self.header_plate(outfile)
		# convert infile
		for line in infile:
			self.element(line, outfile)
			self.parse(line, outfile)
		# finish up outfile
		outfile.write("\\the_end")
		outfile.close()
		

#------------main
converter = FD2LyX()
converter.convert(sys.argv[1])













